/*
Build by Wiquid's PCI Generator for TAO platform Free to use 
 */
define([
    'taoQtiItem/qtiCreator/widgets/states/factory',
    'taoQtiItem/qtiCreator/widgets/interactions/states/Question',
    'taoQtiItem/qtiCreator/widgets/helpers/formElement',
    'taoQtiItem/qtiCreator/editor/simpleContentEditableElement',
    'taoQtiItem/qtiCreator/editor/containerEditor',
    'tpl!wonderpci/creator/tpl/propertiesForm',
    'lodash',
    'jquery'
], function(stateFactory, Question, formElement, simpleEditor, containerEditor, formTpl, _, $) {
    'use strict';

    console.log("From Question Root");


    var wonderpciStateQuestion = stateFactory.extend(Question, function() {

        console.log("From Question wonderpciStateQuestion");

        var $container = this.widget.$container,
            $prompt = $container.find('.prompt'),
            interaction = this.widget.element;

        containerEditor.create($prompt, {
            change: function(text) {
                interaction.data('prompt', text);
                interaction.updateMarkup();
            },
            markup: interaction.markup,
            markupSelector: '.prompt',
            related: interaction
        });

    }, function() {
        var $container = this.widget.$container,
            $prompt = $container.find('.prompt');
        simpleEditor.destroy($container);
        containerEditor.destroy($prompt);
    });

    wonderpciStateQuestion.prototype.initForm = function() {

        console.log("From Question wonderpciStateQuestion");
        var _widget = this.widget,
            $form = _widget.$form,
            interaction = _widget.element,
            response = interaction.getResponseDeclaration();

        //init form javascript
        formElement.initWidget($form);

        //init data change callbacks
        formElement.setChangeCallbacks($form, interaction, {

            identifier: function(i, value) {
                response.id(value);
                interaction.attr('responseIdentifier', value);
            }
        });

    };

    return wonderpciStateQuestion;
});