/*
Build by Wiquid's PCI Generator for TAO platform Free to use 
 */

define([
    'lodash',
    'wonderpci/creator/widget/Widget',
    'tpl!wonderpci/creator/tpl/markup'
], function(_, Widget, markupTpl) {
    'use strict';

    var _typeIdentifier = 'wonderpci';

    var wonderpciCreator = {
        /**
         * (required) Get the typeIdentifier of the custom interaction
         * 
         * @returns {String}
         */
        getTypeIdentifier: function() {
            return _typeIdentifier;
        },
        /**
         * (required) Get the widget prototype
         * Used in the renderer
         * 
         * @returns {Object} Widget
         */
        getWidget: function() {
            return Widget;
        },
        /**
         * (optional) Get the default properties values of the pci.
         * Used on new pci instance creation
         * 
         * @returns {Object}
         */
        getDefaultProperties: function(pci) {
            return {
                stage: '{ "attrs": { "width": 600, "height": 300 }, "className": "Stage", "children": [{ "attrs": {}, "className": "Layer", "children": [{ "attrs": { "x": 300, "y": 150, "radius": 70, "fill": "red", "stroke": "black", "strokeWidth": 4 }, "className": "Circle" }] }] }',
                param: '{"itemChoiceLimit":"GOOD"}'
            };
        },
        /**
         * (optional) Callback to execute on the 
         * Used on new pci instance creation
         * 
         * @returns {Object}
         */
        afterCreate: function(pci) {
            //do some stuff
        },
        /**
         * (required) Gives the qti pci xml template 
         * 
         * @returns {function} handlebar template
         */
        getMarkupTemplate: function() {
            return markupTpl;
        },
        /**
         * (optional) Allows passing additional data to xml template
         * 
         * @returns {function} handlebar template
         */
        getMarkupData: function(pci, defaultData) {
            defaultData.prompt = pci.data('prompt');
            return defaultData;
        }
    };

    //since we assume we are in a tao context, there is no use to expose the a global object for lib registration
    //all libs should be declared here
    return wonderpciCreator;
});